#ifndef __JHEAPS_CAPI_TYPES
#define __JHEAPS_CAPI_TYPES

typedef enum {
    STATUS_SUCCESS = 0, 
    STATUS_ERROR,
    STATUS_ILLEGAL_ARGUMENT,
    STATUS_UNSUPPORTED_OPERATION,
    STATUS_INDEX_OUT_OF_BOUNDS,
    STATUS_NO_SUCH_ELEMENT,
    STATUS_NULL_POINTER,
    STATUS_CLASS_CAST,
    STATUS_IO_ERROR,
    STATUS_ILLEGAL_STATE,
} status_t;

typedef enum {
    HEAP_TYPE_MERGEABLE_ADDRESSABLE_FIBONACCI = 0,
    HEAP_TYPE_MERGEABLE_ADDRESSABLE_FIBONACCI_SIMPLE,
    HEAP_TYPE_MERGEABLE_ADDRESSABLE_PAIRING,
    HEAP_TYPE_MERGEABLE_ADDRESSABLE_PAIRING_RANK,
    HEAP_TYPE_MERGEABLE_ADDRESSABLE_PAIRING_COSTLESSMELD,
    HEAP_TYPE_MERGEABLE_ADDRESSABLE_HOLLOW,
    HEAP_TYPE_MERGEABLE_ADDRESSABLE_LEFTIST,
    HEAP_TYPE_MERGEABLE_ADDRESSABLE_SKEW,
    
    HEAP_TYPE_BINARY_IMPLICIT,
    HEAP_TYPE_BINARY_IMPLICIT_WEAK,
    HEAP_TYPE_BINARY_IMPLICIT_WEAK_BULKINSERT,
    HEAP_TYPE_ADDRESSABLE_BINARY_IMPLICIT,
    HEAP_TYPE_ADDRESSABLE_BINARY_EXPLICIT,
    
    HEAP_TYPE_DARY_IMPLICIT,
    HEAP_TYPE_ADDRESSABLE_DARY_IMPLICIT,
    HEAP_TYPE_ADDRESSABLE_DARY_EXPLICIT,
    
    HEAP_TYPE_MERGEABLE_ADDRESSABLE_BINARY_EXPLICIT_SOFT,
    
    HEAP_TYPE_DOUBLEENDED_BINARY_IMPLICIT_MINMAX,
    HEAP_TYPE_DOUBLEENDED_MERGEABLE_ADDRESSABLE_FIBONACCI_REFLECTED,
    HEAP_TYPE_DOUBLEENDED_MERGEABLE_ADDRESSABLE_PAIRING_REFLECTED,
    
    HEAP_TYPE_MONOTONE_LONG_RADIX,
    HEAP_TYPE_MONOTONE_ADDRESSABLE_LONG_RADIX,
    HEAP_TYPE_MONOTONE_DOUBLE_RADIX,
    HEAP_TYPE_MONOTONE_ADDRESSABLE_DOUBLE_RADIX
} heap_type_t;

#endif
